// RSSMA_Double_Pulse.cpp : implementation file
//

#include "stdafx.h"
#include "RSSMA_PULM_Example.h"
#include "RSSMA_Double_Pulse.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRSSMA_Double_Pulse dialog


CRSSMA_Double_Pulse::CRSSMA_Double_Pulse(CWnd* pParent /*=NULL*/)
	: CDialog(CRSSMA_Double_Pulse::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRSSMA_Double_Pulse)
	m_DPulDelay = 1.0e-3;
	m_DPulWidth = 1.0e-3;
	//}}AFX_DATA_INIT
}


void CRSSMA_Double_Pulse::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRSSMA_Double_Pulse)
	DDX_Text(pDX, IDC_DPUL_DELAY, m_DPulDelay);
	DDX_Text(pDX, IDC_DPUL_WIDTH, m_DPulWidth);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRSSMA_Double_Pulse, CDialog)
	//{{AFX_MSG_MAP(CRSSMA_Double_Pulse)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSSMA_Double_Pulse message handlers

void CRSSMA_Double_Pulse::getValues(double* dPulseWidth, double* dPulseDelay)
{
	*dPulseWidth = m_DPulWidth;
	*dPulseDelay = m_DPulDelay;
}

