// RSSMA_External_FM_ExampleDlg.h : header file
//

#if !defined(AFX_RSSMA_EXTERNAL_FM_EXAMPLEDLG_H__6E738AFB_2A82_4B1D_B857_D5D0D1F4DC02__INCLUDED_)
#define AFX_RSSMA_EXTERNAL_FM_EXAMPLEDLG_H__6E738AFB_2A82_4B1D_B857_D5D0D1F4DC02__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/* Error check macro for driver functions */

#define FT_CHECKERR(fcal, err) if ((rssma_status = fcal) < 0){\
								 rssma_close(instrSession);\
        						 sprintf (buffer, "Error: %ld, %s", rssma_status, err);\
        						 GetDlgItem(IDAPPLY)->EnableWindow (TRUE);\
								 AfxMessageBox (buffer, MB_OK);\
        						 return;\
        						 }

/////////////////////////////////////////////////////////////////////////////
// CRSSMA_External_FM_ExampleDlg dialog

class CRSSMA_External_FM_ExampleDlg : public CDialog
{
// Construction
public:
	CRSSMA_External_FM_ExampleDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CRSSMA_External_FM_ExampleDlg)
	enum { IDD = IDD_RSSMA_EXTERNAL_FM_EXAMPLE_DIALOG };
	CButton	m_FMState;
	CButton	m_Exit;
	CButton	m_Apply;
	int		m_FMMode;
	BOOL	m_Query;
	BOOL	m_Reset;
	CString	m_ResName;
	double	m_RFFreq;
	double	m_RFLevel;
	BOOL	m_RFState;
	int		m_FMExtCoupling;
	double	m_FMExtDev;
	int		m_FMExtImp;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRSSMA_External_FM_ExampleDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON	m_hIcon;
	BOOL	bFMState;
	// Generated message map functions
	//{{AFX_MSG(CRSSMA_External_FM_ExampleDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnApply();
	afx_msg void OnFmstate();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RSSMA_EXTERNAL_FM_EXAMPLEDLG_H__6E738AFB_2A82_4B1D_B857_D5D0D1F4DC02__INCLUDED_)
