// RSSMA_External_PM_ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RSSMA_External_PM_Example.h"
#include "RSSMA_External_PM_ExampleDlg.h"
#include "rssma.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSSMA_External_PM_ExampleDlg dialog

CRSSMA_External_PM_ExampleDlg::CRSSMA_External_PM_ExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRSSMA_External_PM_ExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRSSMA_External_PM_ExampleDlg)
	m_Query = TRUE;
	m_PMExtCoupling = 0;
	m_PMExtDev = 1.0;
	m_PMExtImpedance = 0;
	m_PMMode = 0;
	m_Reset = TRUE;
	m_ResName = _T("GPIB::28");
	m_RFFreq = 1.0e9;
	m_RFLevel = -30.0;
	m_RFState = FALSE;
	bPMState = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRSSMA_External_PM_ExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRSSMA_External_PM_ExampleDlg)
	DDX_Control(pDX, IDPMSTATE, m_PMState);
	DDX_Control(pDX, IDCANCEL, m_Exit);
	DDX_Control(pDX, IDAPPLY, m_Apply);
	DDX_Check(pDX, IDC_ID_QUERY, m_Query);
	DDX_CBIndex(pDX, IDC_PM_EXT_COUPLING, m_PMExtCoupling);
	DDX_Text(pDX, IDC_PM_EXT_DEV, m_PMExtDev);
	DDX_CBIndex(pDX, IDC_PM_EXT_IMPEDANCE, m_PMExtImpedance);
	DDX_CBIndex(pDX, IDC_PM_MODE, m_PMMode);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_Text(pDX, IDC_RESOURCE_DESCRIPTOR, m_ResName);
	DDX_Text(pDX, IDC_RF_FREQ, m_RFFreq);
	DDX_Text(pDX, IDC_RF_LEVEL, m_RFLevel);
	DDX_Check(pDX, IDC_RF_STATE, m_RFState);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRSSMA_External_PM_ExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CRSSMA_External_PM_ExampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDPMSTATE, OnPmstate)
	ON_BN_CLICKED(IDAPPLY, OnApply)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSSMA_External_PM_ExampleDlg message handlers

BOOL CRSSMA_External_PM_ExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRSSMA_External_PM_ExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRSSMA_External_PM_ExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRSSMA_External_PM_ExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRSSMA_External_PM_ExampleDlg::OnPmstate() 
{
	CString label;

	bPMState = !bPMState;
	if (bPMState)
		label = "On";
	else
		label = "Off";

	m_PMState.SetWindowText(label);		
}

void CRSSMA_External_PM_ExampleDlg::OnApply() 
{
	ViStatus	rssma_status;
	ViSession	instrSession;
	char		buffer[512];
	HCURSOR		cur;

	cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );
	
	GetDlgItem(IDAPPLY)->EnableWindow (FALSE);
	GetDlgItem(IDCANCEL)->EnableWindow (FALSE);
	
	UpdateData();

    /* Initialize the driver */
	rssma_status = rssma_init((char *) ((LPCTSTR) m_ResName), (int)(m_Query), (int)(m_Reset), &instrSession);
	if (rssma_status < 0)
	{
		AfxMessageBox ("Could not open the session!", MB_OK);
		cur = LoadCursor ( NULL, IDC_ARROW );
		SetCursor ( cur );

		GetDlgItem(IDAPPLY)->EnableWindow (TRUE);
		GetDlgItem(IDCANCEL)->EnableWindow (TRUE);
		return;
	}

	//For Syncronisation 
	//Enable Operation Complete for STB Register
	FT_CHECKERR (rssma_EventStatusEnable(instrSession,1), "rssma_EventStatusEnable");
	//Clear Status
	FT_CHECKERR (rssma_ClearStatus(instrSession),"rssma_ClearStatus");	


    /* Turn On/Off RF output at the end of sequence */
    FT_CHECKERR (rssma_SetOutputState(instrSession, m_RFState), "rssma_SetOutputState");

	if (m_RFState)
	{
		FT_CHECKERR (rssma_confRFFreq (instrSession, m_RFFreq, 0.0, FALSE, 0.0), "rssma_confRFFreq");
		FT_CHECKERR (rssma_confRFLevel (instrSession, m_RFLevel, 0.0, 30.0, FALSE, 0.0,
											RSSMA_OUTPUT_AMODE_AUTO, RSSMA_POWER_LEVEL_RCL_EXCLUDE), 
											"rssma_confRFLevel");
		FT_CHECKERR (rssma_confPM (instrSession, bPMState, RSSMA_FM_SOURCE_EXTERNAL, m_PMMode,
										m_PMExtDev, 0.5, m_PMExtDev, m_PMExtCoupling, m_PMExtImpedance,
										RSSMA_FM_EXTERNAL_DIGITAL_FORMAT_BOFFSET), "rssma_confPM");
	}

	rssma_close(instrSession);

	GetDlgItem(IDAPPLY)->EnableWindow (TRUE);
	GetDlgItem(IDCANCEL)->EnableWindow (TRUE);

	cur = LoadCursor ( NULL, IDC_ARROW );
	SetCursor ( cur );

    return;
}
