// RSSMA_List_Mode_ExampleDlg.h : header file
//

#if !defined(AFX_RSSMA_LIST_MODE_EXAMPLEDLG_H__F6A5721C_0858_4DAC_9B97_E00422E61707__INCLUDED_)
#define AFX_RSSMA_LIST_MODE_EXAMPLEDLG_H__F6A5721C_0858_4DAC_9B97_E00422E61707__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "rssma.h"

/* Error check macro for driver functions */
#define FT_CHECKERR(fcal, err) if ((rssma_status = fcal) < 0){\
        						 sprintf (buffer, "Error: %ld, %s", rssma_status, err);\
        						 GetDlgItem(IDAPPLY)->EnableWindow (TRUE);\
        						 GetDlgItem(IDCANCEL)->EnableWindow (TRUE);\
								 AfxMessageBox (buffer, MB_OK);\
        						 return;\
        						 }

/////////////////////////////////////////////////////////////////////////////
// CRSSMA_List_Mode_ExampleDlg dialog

class CRSSMA_List_Mode_ExampleDlg : public CDialog
{
// Construction
public:
	CRSSMA_List_Mode_ExampleDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CRSSMA_List_Mode_ExampleDlg)
	enum { IDD = IDD_RSSMA_LIST_MODE_EXAMPLE_DIALOG };
	CComboBox	m_ListCtrl;
	CStatic	m_TrigSlopeText;
	CComboBox	m_TrigSlopeCtrl;
	CButton	m_Exit;
	CButton	m_FillList;
	CButton	m_Apply;
	CString	m_DirName;
	int		m_List;
	int		m_ListMode;
	BOOL	m_Reset;
	CString	m_ResName;
	BOOL	m_RFState;
	double	m_DwellTime;
	int		m_TrigSlope;
	BOOL	m_Query;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRSSMA_List_Mode_ExampleDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON		m_hIcon;
	ViSession	instrSession;

	// Generated message map functions
	//{{AFX_MSG(CRSSMA_List_Mode_ExampleDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSelchangeListMode();
	afx_msg void OnFillList();
	afx_msg void OnApply();
	afx_msg void OnExit();
	//}}AFX_MSG
	int initialize (void);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RSSMA_LIST_MODE_EXAMPLEDLG_H__F6A5721C_0858_4DAC_9B97_E00422E61707__INCLUDED_)
