// RSSMA_Noise.cpp : implementation file
//

#include "stdafx.h"
#include "RSSMA_PM_Example.h"
#include "RSSMA_Noise.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRSSMA_Noise dialog


CRSSMA_Noise::CRSSMA_Noise(CWnd* pParent /*=NULL*/)
	: CDialog(CRSSMA_Noise::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRSSMA_Noise)
	m_NoiseBwid = 100.0e3;
	m_NoiseBwidLim = FALSE;
	m_NoiseDistribution = 0;
	//}}AFX_DATA_INIT
}


void CRSSMA_Noise::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRSSMA_Noise)
	DDX_Control(pDX, IDC_NOISE_BWID, m_NoiseBwidCtrl);
	DDX_Text(pDX, IDC_NOISE_BWID, m_NoiseBwid);
	DDX_Check(pDX, IDC_NOISE_BWID_LIM, m_NoiseBwidLim);
	DDX_CBIndex(pDX, IDC_NOISE_DISTRIBUTION, m_NoiseDistribution);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRSSMA_Noise, CDialog)
	//{{AFX_MSG_MAP(CRSSMA_Noise)
	ON_BN_CLICKED(IDC_NOISE_BWID_LIM, OnNoiseBwidLim)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSSMA_Noise message handlers


void CRSSMA_Noise::getValues(double* noiseBwid, BOOL* noiseBwidLim, int* noiseDistrib)
{
	*noiseBwid = m_NoiseBwid;
	*noiseBwidLim = m_NoiseBwidLim;
	*noiseDistrib = m_NoiseDistribution;
}

BOOL CRSSMA_Noise::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	if(!m_NoiseBwidLim)
		m_NoiseBwidCtrl.EnableWindow(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CRSSMA_Noise::OnNoiseBwidLim() 
{
	UpdateData(TRUE);

	if(m_NoiseBwidLim)
		m_NoiseBwidCtrl.EnableWindow(TRUE);	
	else
		m_NoiseBwidCtrl.EnableWindow(FALSE);	
}
