// RSSMA_External_AM_ExampleDlg.h : header file
//

#if !defined(AFX_RSSMA_EXTERNAL_AM_EXAMPLEDLG_H__D37685D9_C067_4272_B703_D506E0E1A55A__INCLUDED_)
#define AFX_RSSMA_EXTERNAL_AM_EXAMPLEDLG_H__D37685D9_C067_4272_B703_D506E0E1A55A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/* Error check macro for driver functions */

#define FT_CHECKERR(fcal, err) if ((rssma_status = fcal) < 0){\
								 rssma_close(instrSession);\
        						 sprintf (buffer, "Error: %ld, %s", rssma_status, err);\
        						 GetDlgItem(IDAPPLY)->EnableWindow (TRUE);\
        						 GetDlgItem(IDCANCEL)->EnableWindow (TRUE);\
								 AfxMessageBox (buffer, MB_OK);\
        						 return;\
        						 }

/////////////////////////////////////////////////////////////////////////////
// CRSSMA_External_AM_ExampleDlg dialog

class CRSSMA_External_AM_ExampleDlg : public CDialog
{
// Construction
public:
	CRSSMA_External_AM_ExampleDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CRSSMA_External_AM_ExampleDlg)
	enum { IDD = IDD_RSSMA_EXTERNAL_AM_EXAMPLE_DIALOG };
	CButton	m_Exit;
	CButton	m_Apply;
	CButton	m_AMState;
	BOOL	m_Query;
	BOOL	m_Reset;
	CString	m_ResName;
	double	m_RFFreq;
	double	m_RFLevel;
	BOOL	m_RFState;
	double	m_AMDepth;
	int		m_AMExtCoupling;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRSSMA_External_AM_ExampleDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON	m_hIcon;
	BOOL	bAMState;

	// Generated message map functions
	//{{AFX_MSG(CRSSMA_External_AM_ExampleDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnAmstate();
	afx_msg void OnApply();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RSSMA_EXTERNAL_AM_EXAMPLEDLG_H__D37685D9_C067_4272_B703_D506E0E1A55A__INCLUDED_)
