// RSSMA_LFGen1.cpp : implementation file
//

#include "stdafx.h"
#include "RSSMA_AM_Example.h"
#include "RSSMA_AM_ExampleDlg.h"
#include "RSSMA_LFGen1.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRSSMA_LFGen1 dialog


CRSSMA_LFGen1::CRSSMA_LFGen1(CWnd* pParent /*=NULL*/)
	: CDialog(CRSSMA_LFGen1::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRSSMA_LFGen1)
	m_LFGen1Freq = 1.0e3;
	m_LFGen1Depth = 30.0;
	//}}AFX_DATA_INIT
	bEnabledDepth = TRUE;
}


void CRSSMA_LFGen1::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRSSMA_LFGen1)
	DDX_Control(pDX, IDC_LFGEN1_DEPTH, m_LFGen1DepthCtrl);
	DDX_Text(pDX, IDC_LFGEN1_FREQ, m_LFGen1Freq);
	DDX_Text(pDX, IDC_LFGEN1_DEPTH, m_LFGen1Depth);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRSSMA_LFGen1, CDialog)
	//{{AFX_MSG_MAP(CRSSMA_LFGen1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSSMA_LFGen1 message handlers

void CRSSMA_LFGen1::getValues(double* depth, double* frequency)
{
	*depth = m_LFGen1Depth;
	*frequency = m_LFGen1Freq;
}

void CRSSMA_LFGen1::setDepthEnabled(BOOL enabled)
{
	bEnabledDepth = enabled;
}

BOOL CRSSMA_LFGen1::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	if (!bEnabledDepth) 
		m_LFGen1DepthCtrl.EnableWindow(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
